#Copyright 2009 Anton Vorobyov
#
#This program is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program.  If not, see <http://www.gnu.org/licenses/>.
'''
This script detects implemented effects which are unused in current sqlite database
'''
import sys
sys.path.append("..")

import sql
import os.path
import re

effectsPath = os.path.join("..", "effects")

sql.connect("sqlite")
c = sql.getConnection().cursor()
query = 'SELECT invTypes.published, dgmEffects.effectName FROM invTypes \
INNER JOIN dgmTypeEffects ON dgmTypeEffects.typeID = invTypes.typeID INNER \
JOIN dgmEffects ON dgmEffects.effectID = dgmTypeEffects.effectID'
c.execute(query)
dbDict = {}
for row in c:
    #'&', spaces and tab symbols need to be filtered as pyfa also doesn't use them
    subbedName = re.sub("[&\t ]", "",row[1])
    if not subbedName in dbDict or dbDict[subbedName] == 0: dbDict[subbedName] = row[0]

print '[-] - not used by any item\n[?] - used by unpublished items only\n'
for filename in os.listdir(effectsPath):
    basename, extension = filename.split('.')
    #Ignore non-py files and exclude 2 pyfa-specific 'effects'
    if extension == "py" and basename != "__init__" and basename != "customEffects":
        if not basename in dbDict:
            print '[-] ' + basename
        elif dbDict[basename] == 0:
            print '[?] ' + basename
